diff --git a/game/core/src/main/java/net/minecraft/core/net/command/helpers/EntitySelector.java b/game/core/src/main/java/net/minecraft/core/net/command/helpers/EntitySelector.java
index dfb149799..7d3a2a559 100644
--- a/game/core/src/main/java/net/minecraft/core/net/command/helpers/EntitySelector.java
+++ b/game/core/src/main/java/net/minecraft/core/net/command/helpers/EntitySelector.java
@@ -51,7 +51,7 @@ public class EntitySelector {
         // Entity ID/player
         if (this.entityId != null) {
             List<Entity> entities = new ArrayList<>();
-            for (Entity entity : source.getWorld().loadedEntityList) {
+            for (Entity entity : source.getWorld().entities) {
                 if ((ENTITY_PREFIX + entity.hashCode()).equals(this.entityId)) {
                     entities.add(entity);
                 }
@@ -79,7 +79,7 @@ public class EntitySelector {
                 entities = Collections.singletonList(source.getSender());
             }
         } else if (this.includesEntities) {
-            entities = source.getWorld().loadedEntityList;
+            entities = source.getWorld().entities;
         } else {
             entities = source.getWorld().players;
         }
diff --git a/game/core/src/main/java/net/minecraft/core/world/PortalHandler.java b/game/core/src/main/java/net/minecraft/core/world/PortalHandler.java
index 7cf290f5a..8a35b76fe 100644
--- a/game/core/src/main/java/net/minecraft/core/world/PortalHandler.java
+++ b/game/core/src/main/java/net/minecraft/core/world/PortalHandler.java
@@ -153,7 +153,7 @@ public class PortalHandler
             {
                 newEntityZ += 0.5D;
             }
-            entity.moveTo(newEntityX, newEntityY - 0.5f, newEntityZ, entity.yRot, 0.0F);
+            entity.moveTo(newEntityX, newEntityY, newEntityZ, entity.yRot, 0.0F);
             entity.xd = entity.yd = entity.zd = 0.0D;
             return true;
         }
diff --git a/game/core/src/main/java/net/minecraft/core/world/World.java b/game/core/src/main/java/net/minecraft/core/world/World.java
index 781685bde..57433468e 100644
--- a/game/core/src/main/java/net/minecraft/core/world/World.java
+++ b/game/core/src/main/java/net/minecraft/core/world/World.java
@@ -2,20 +2,12 @@ package net.minecraft.core.world;
 
 import static net.minecraft.core.Global.*;
 
-import java.util.ArrayList;
-import java.util.Collection;
-import java.util.HashSet;
-import java.util.List;
-import java.util.Random;
-import java.util.Set;
-import java.util.TreeSet;
-import java.util.UUID;
+import java.util.*;
 
 import com.mojang.logging.LogUtils;
 
 import net.minecraft.core.block.entity.TileEntity;
 import net.minecraft.core.block.support.ISupport;
-import net.minecraft.core.block.support.ISupportable;
 import net.minecraft.core.block.support.PartialSupport;
 import net.minecraft.core.current.wire.WireHandler;
 import net.minecraft.core.entity.EntityItem;
@@ -90,19 +82,18 @@ public class World implements WorldSource {
     public static final int MAX_SCHEDULED_TICKS_IN_TICK = 1000;
     public static final int ANIMATION_TICKS_PER_TICK = 1000;
 
-    public List<Entity> loadedEntityList = new ArrayList<>();
-    private final List<Entity> unloadedEntityList = new ArrayList<>();
-    private final TreeSet<NextTickListEntry> scheduledTickTreeSet = new TreeSet<>();
-    private final Set<NextTickListEntry> scheduledTickSet = new HashSet<>();
-    public List<TileEntity> loadedTileEntityList = new ArrayList<>();
-    public List<Player> players = new ArrayList<>();
-    public List<Entity> weatherEffects = new ArrayList<>();
-    public final ArrayList<AABB> collidingBoundingBoxes = new ArrayList<>();
-    public List<LevelListener> listeners = new ArrayList<>();
-    private final Set<ChunkCoordinate> positionsToUpdate = new HashSet<>();
-    private final List<Entity> entityBuffer = new ArrayList<Entity>();
-    private final Set<NextTickListEntry> immediatelyUpdatedPositions = new HashSet<>();
-    
+    public final @NotNull List<@NotNull Entity> entities = new ArrayList<>();
+    private final @NotNull List<@NotNull Entity> entitiesToRemove = new ArrayList<>();
+    private final @NotNull TreeSet<@NotNull NextTickListEntry> tickNextTickList = new TreeSet<>();
+    public final @NotNull List<@NotNull TileEntity> tileEntityList = new ArrayList<>();
+    public final @NotNull List<@NotNull Player> players = new ArrayList<>();
+    public final @NotNull List<@NotNull Entity> weatherEffects = new ArrayList<>();
+    public final @NotNull ArrayList<@NotNull AABB> collidingBoundingBoxes = new ArrayList<>();
+    public final @NotNull List<@NotNull LevelListener> listeners = new ArrayList<>();
+    private final @NotNull Set<@NotNull ChunkCoordinate> positionsToUpdate = new HashSet<>();
+    private final @NotNull List<@NotNull Entity> entityBuffer = new ArrayList<>();
+    private final @NotNull Set<@NotNull NextTickListEntry> immediatelyUpdatedPositions = new HashSet<>();
+
     public boolean scheduledUpdatesAreImmediate = false;
     public int skyDarken = 0;
     protected int updateLCG = new Random().nextInt();
@@ -112,8 +103,7 @@ public class World implements WorldSource {
     public boolean dayCanHaveRainbow = true;
     public boolean noNeighborUpdate = false;
     private long lockTimestamp = System.currentTimeMillis();
-    //protected int autosavePeriod = 40;
-    public Random rand = new Random();
+    public final @NotNull Random rand = new Random();
     public boolean isNewWorld = false;
     public Dimension dimension;
     public WorldType worldType;
@@ -127,7 +117,7 @@ public class World implements WorldSource {
     protected final LightingEngine lightingEngine = new LightingEngineLegacy(this);
     private boolean updatingBlockEntities;
 
-    private int caveSoundCounter = rand.nextInt(12000);
+    private int caveSoundCounter = this.rand.nextInt(12000);
     public boolean isClientSide = false;
     public int sleepPercent = 100;
     private long runtime = 0;
@@ -1401,7 +1391,7 @@ public class World implements WorldSource {
             }
 
             getChunkFromChunkCoords(i, j).addEntity(entity);
-            loadedEntityList.add(entity);
+            entities.add(entity);
             obtainEntitySkin(entity);
             return true;
         } else
@@ -1460,7 +1450,7 @@ public class World implements WorldSource {
         {
             getChunkFromChunkCoords(i, j).removeEntity(entity);
         }
-        loadedEntityList.remove(entity);
+        entities.remove(entity);
         releaseEntitySkin(entity);
     }
 
@@ -1655,12 +1645,17 @@ public class World implements WorldSource {
         return f2 * f2 * 0.5F;
     }
 
-    public void scheduleBlockUpdate(int x, int y, int z, int id, int delay) {
-        NextTickListEntry entry = new NextTickListEntry(x, y, z, id);
+    public void scheduleBlockUpdate(int x, int y, int z, int id, long delay) {
+        this.scheduleBlockUpdate(x, y, z, id, delay, false);
+    }
+
+    public void scheduleBlockUpdate(int x, int y, int z, int id, long delay, boolean loaded) {
+        NextTickListEntry entry = new NextTickListEntry(x, y, z, id, getWorldTime());
+        entry.loaded = loaded;
         byte radius = 8;
 
         if(scheduledUpdatesAreImmediate && !immediatelyUpdatedPositions.contains(entry)) {
-            if(areBlocksLoaded(entry.x - radius, entry.y - radius, entry.z - radius, entry.x + radius, entry.y + radius, entry.z + radius)) {
+            if(entry.loaded || areBlocksLoaded(entry.x - radius, entry.y - radius, entry.z - radius, entry.x + radius, entry.y + radius, entry.z + radius)) {
                 int id1 = getBlockId(entry.x, entry.y, entry.z);
                 if(id1 == entry.blockId && id1 > 0) {
                     immediatelyUpdatedPositions.add(entry);
@@ -1669,13 +1664,14 @@ public class World implements WorldSource {
             }
             return;
         }
-        if(areBlocksLoaded(x - radius, y - radius, z - radius, x + radius, y + radius, z + radius)) {
+        if(entry.loaded || areBlocksLoaded(x - radius, y - radius, z - radius, x + radius, y + radius, z + radius)) {
             if(id > 0) {
-                entry.setDelay((long) delay + runtime);
+                entry.setDelay(delay);
             }
-            if(!scheduledTickSet.contains(entry)) {
-                scheduledTickSet.add(entry);
-                scheduledTickTreeSet.add(entry);
+            if(!tickNextTickList.contains(entry)) {
+                tickNextTickList.add(entry);
+                final @NotNull Chunk chunk = Objects.requireNonNull(this.getChunkFromBlockCoords(x, z));
+                chunk.addTick(entry);
             }
         }
     }
@@ -1691,10 +1687,10 @@ public class World implements WorldSource {
             }
         }
 
-        loadedEntityList.removeAll(unloadedEntityList);
-        for(int j = 0; j < unloadedEntityList.size(); j++)
+        entities.removeAll(entitiesToRemove);
+        for(int j = 0; j < entitiesToRemove.size(); j++)
         {
-            Entity entity1 = unloadedEntityList.get(j);
+            Entity entity1 = entitiesToRemove.get(j);
             int i1 = entity1.chunkCoordX;
             int k1 = entity1.chunkCoordZ;
             if(entity1.addedToChunk && isChunkLoaded(i1, k1))
@@ -1703,15 +1699,15 @@ public class World implements WorldSource {
             }
         }
 
-        for(int k = 0; k < unloadedEntityList.size(); k++)
+        for(int k = 0; k < entitiesToRemove.size(); k++)
         {
-            releaseEntitySkin(unloadedEntityList.get(k));
+            releaseEntitySkin(entitiesToRemove.get(k));
         }
 
-        unloadedEntityList.clear();
-        for(int l = 0; l < loadedEntityList.size(); l++)
+        entitiesToRemove.clear();
+        for(int l = 0; l < entities.size(); l++)
         {
-            Entity entity2 = loadedEntityList.get(l);
+            Entity entity2 = entities.get(l);
             if(entity2.vehicle != null)
             {
                 if(!entity2.vehicle.isRemoved() && entity2.vehicle.getPassenger() == entity2)
@@ -1735,18 +1731,18 @@ public class World implements WorldSource {
             {
                 getChunkFromChunkCoords(j1, l1).removeEntity(entity2);
             }
-            loadedEntityList.remove(l--);
+            entities.remove(l--);
             releaseEntitySkin(entity2);
         }
 
         updatingBlockEntities = true;
-        for (int i = loadedTileEntityList.size() - 1; i >= 0; i--) {
-            TileEntity tileEntity = loadedTileEntityList.get(i);
+        for (int i = tileEntityList.size() - 1; i >= 0; i--) {
+            TileEntity tileEntity = tileEntityList.get(i);
             if (!tileEntity.isInvalid() && isBlockLoaded(tileEntity.x, tileEntity.y, tileEntity.z)) {
                 tileEntity.tick();
             }
             if (tileEntity.isInvalid()) {
-                loadedTileEntityList.remove(i);
+                tileEntityList.remove(i);
                 Chunk chunk = getChunkFromChunkCoords(Math.floorDiv(tileEntity.x, Chunk.CHUNK_SIZE_X), Math.floorDiv(tileEntity.z, Chunk.CHUNK_SIZE_Z));
                 if (chunk != null) {
                     chunk.removeTileEntity(tileEntity);
@@ -1758,7 +1754,7 @@ public class World implements WorldSource {
 
     public void addAllBlockEntities(Collection<TileEntity> blockEntities)
     {
-        loadedTileEntityList.addAll(blockEntities);
+        tileEntityList.addAll(blockEntities);
     }
 
     public void updateEntity(Entity entity)
@@ -2132,9 +2128,9 @@ public class World implements WorldSource {
 
     public @Nullable Entity getEntityByID(int id)
     {
-        for(int i = 0; i < loadedEntityList.size(); i++)
+        for(int i = 0; i < entities.size(); i++)
         {
-            Entity entity = loadedEntityList.get(i);
+            Entity entity = entities.get(i);
             if(entity.id == id)
             {
                 return entity;
@@ -2146,7 +2142,7 @@ public class World implements WorldSource {
 
     public String getNumLoadedEntitiesString()
     {
-        return "All: " + loadedEntityList.size();
+        return "All: " + entities.size();
     }
 
     public String getChunkProviderInfoString()
@@ -2174,8 +2170,8 @@ public class World implements WorldSource {
             Chunk chunk = getChunkFromChunkCoords(Math.floorDiv(x, Chunk.CHUNK_SIZE_X), Math.floorDiv(z, Chunk.CHUNK_SIZE_Z));
             if(chunk != null)
             {
-                if (chunk.setTileEntity(x & (Chunk.CHUNK_SIZE_X - 1), y, z & (Chunk.CHUNK_SIZE_Z - 1), tileEntity) && !loadedTileEntityList.contains(tileEntity)) {
-                    loadedTileEntityList.add(tileEntity);
+                if (chunk.setTileEntity(x & (Chunk.CHUNK_SIZE_X - 1), y, z & (Chunk.CHUNK_SIZE_Z - 1), tileEntity) && !tileEntityList.contains(tileEntity)) {
+                    tileEntityList.add(tileEntity);
                 }
             }
         }
@@ -2192,7 +2188,7 @@ public class World implements WorldSource {
         {
             if(tileEntity != null)
             {
-                loadedTileEntityList.remove(tileEntity);
+                tileEntityList.remove(tileEntity);
             }
             Chunk chunk = getChunkFromChunkCoords(Math.floorDiv(x, Chunk.CHUNK_SIZE_X), Math.floorDiv(z, Chunk.CHUNK_SIZE_Z));
             if(chunk != null)
@@ -2267,8 +2263,8 @@ public class World implements WorldSource {
             LOGGER.error("Unhandled exception while unloading all entities!", t);
             throw t;
         } finally {
-            loadedEntityList.clear();
-            unloadedEntityList.clear();
+            entities.clear();
+            entitiesToRemove.clear();
         }
     }
 
@@ -2350,7 +2346,7 @@ public class World implements WorldSource {
 
         runtime++;
 
-        tickUpdates(false);
+        tickPendingTicks(false);
         Debug.change("blocks&cavesSounds");
         updateBlocksAndPlayCaveSounds();
         Debug.change("season&light");
@@ -2462,39 +2458,43 @@ public class World implements WorldSource {
 
     }
 
-    public boolean tickUpdates(boolean all)
-    {
-        int count = scheduledTickTreeSet.size();
-        if(count != scheduledTickSet.size())
-        {
-            throw new IllegalStateException("TickNextTick list out of sync");
-        }
+    public boolean tickPendingTicks(final boolean all) {
+        int count = this.tickNextTickList.size();
         if(count > MAX_SCHEDULED_TICKS_IN_TICK)
         {
             count = MAX_SCHEDULED_TICKS_IN_TICK;
         }
-        for(int j = 0; j < count; j++)
+
+        for (int i = 0; i < count; i++)
         {
-            NextTickListEntry entry = scheduledTickTreeSet.first();
-            if(!all && entry.delay > runtime)
+            final @NotNull NextTickListEntry entry = this.tickNextTickList.first();
+            if(!all && entry.getEndTime() > this.getWorldTime())
             {
                 break;
             }
-            scheduledTickTreeSet.remove(entry);
-            scheduledTickSet.remove(entry);
+            if (!entry.loaded) {
+                this.tickNextTickList.remove(entry);
+            }
             final byte radius = 8;
-            if(!areBlocksLoaded(entry.x - radius, entry.y - radius, entry.z - radius, entry.x + radius, entry.y + radius, entry.z + radius))
-            {
+            if(!this.areBlocksLoaded(entry.x - radius, entry.y - radius, entry.z - radius, entry.x + radius, entry.y + radius, entry.z + radius)) {
+                if (entry.loaded) { // Re-insert loaded tick with appropriate delay
+                    entry.creationTime = this.getWorldTime();
+                }
                 continue;
             }
-            int blockId = getBlockId(entry.x, entry.y, entry.z);
-            if(blockId == entry.blockId && blockId > 0)
+            if (entry.loaded) {
+                this.tickNextTickList.remove(entry);
+            }
+            final @NotNull Chunk chunk = Objects.requireNonNull(this.getChunkFromBlockCoords(entry.x, entry.z));
+            chunk.dropTick(entry);
+            final @Nullable Block<?> block = this.getBlock(entry.x, entry.y, entry.z);
+            if(block != null && block.id() == entry.blockId)
             {
-                Blocks.blocksList[blockId].updateTick(this, entry.x, entry.y, entry.z, rand, false);
+                block.updateTick(this, entry.x, entry.y, entry.z, this.rand, false);
             }
         }
 
-        return !scheduledTickTreeSet.isEmpty();
+        return !tickNextTickList.isEmpty();
     }
 
     public void randomDisplayUpdates(int x, int y, int z)
@@ -2559,12 +2559,12 @@ public class World implements WorldSource {
 
     public List<Entity> getLoadedEntityList()
     {
-        return loadedEntityList;
+        return entities;
     }
 
     public List<TileEntity> getLoadedTileEntityList()
     {
-        return loadedTileEntityList;
+        return tileEntityList;
     }
 
     public void updateTileEntityChunkAndSendToPlayer(int x, int y, int z, TileEntity tileEntity)
@@ -2582,7 +2582,7 @@ public class World implements WorldSource {
     public int countEntities(Class<?> clazz)
     {
         int i = 0;
-        for (Entity entity : loadedEntityList) {
+        for (Entity entity : entities) {
             if (clazz.isAssignableFrom(entity.getClass())) {
                 i++;
             }
@@ -2593,7 +2593,7 @@ public class World implements WorldSource {
 
     public void addLoadedEntities(List<Entity> list)
     {
-        loadedEntityList.addAll(list);
+        entities.addAll(list);
         for(int i = 0; i < list.size(); i++)
         {
             obtainEntitySkin(list.get(i));
@@ -2603,7 +2603,7 @@ public class World implements WorldSource {
 
     public void unloadEntities(List<Entity> list)
     {
-        unloadedEntityList.addAll(list);
+        entitiesToRemove.addAll(list);
     }
 
     public void dropOldChunks()
@@ -2901,14 +2901,17 @@ public class World implements WorldSource {
         levelData.setWorldTime(l);
     }
     
-    public void setWorldTimeUpdateTicks(long l)
-    {
-        long l1 = l - levelData.getWorldTime();
-        for (NextTickListEntry nextticklistentry : scheduledTickSet) {
-            nextticklistentry.delay += l1;
+    public void setWorldTimeUpdateTicks(final long ticks) {
+        final long currentTime = this.levelData.getWorldTime();
+        final long newTime = ticks;
+
+        for (final @NotNull NextTickListEntry entry : this.tickNextTickList) {
+            final long ticksRemaining = entry.getEndTime() - currentTime;
+            entry.creationTime = newTime;
+            entry.delay = ticksRemaining;
         }
 
-        setWorldTime(l);
+        this.setWorldTime(ticks);
     }
 
     public long getRandomSeed()
@@ -2956,9 +2959,9 @@ public class World implements WorldSource {
 
         }
 
-        if(!loadedEntityList.contains(entity))
+        if(!entities.contains(entity))
         {
-            loadedEntityList.add(entity);
+            entities.add(entity);
         }
     }
 
@@ -2981,10 +2984,10 @@ public class World implements WorldSource {
 
     public void updateEntityList()
     {
-        loadedEntityList.removeAll(unloadedEntityList);
-        for(int i = 0; i < unloadedEntityList.size(); i++)
+        entities.removeAll(entitiesToRemove);
+        for(int i = 0; i < entitiesToRemove.size(); i++)
         {
-            Entity entity = unloadedEntityList.get(i);
+            Entity entity = entitiesToRemove.get(i);
             int cX = entity.chunkCoordX;
             int cZ = entity.chunkCoordZ;
             if(entity.addedToChunk && isChunkLoaded(cX, cZ))
@@ -2993,15 +2996,15 @@ public class World implements WorldSource {
             }
         }
 
-        for(int j = 0; j < unloadedEntityList.size(); j++)
+        for(int j = 0; j < entitiesToRemove.size(); j++)
         {
-            releaseEntitySkin(unloadedEntityList.get(j));
+            releaseEntitySkin(entitiesToRemove.get(j));
         }
 
-        unloadedEntityList.clear();
-        for(int i = 0; i < loadedEntityList.size(); i++)
+        entitiesToRemove.clear();
+        for(int i = 0; i < entities.size(); i++)
         {
-            Entity entity = loadedEntityList.get(i);
+            Entity entity = entities.get(i);
             if(entity.vehicle != null)
             {
                 if(!entity.vehicle.isRemoved() && entity.vehicle.getPassenger() == entity)
@@ -3021,7 +3024,7 @@ public class World implements WorldSource {
             {
                 getChunkFromChunkCoords(cX, cZ).removeEntity(entity);
             }
-            loadedEntityList.remove(i--);
+            entities.remove(i--);
             releaseEntitySkin(entity);
         }
 
diff --git a/game/core/src/main/java/net/minecraft/core/world/chunk/Chunk.java b/game/core/src/main/java/net/minecraft/core/world/chunk/Chunk.java
index f0397e2bc..16c7d2869 100644
--- a/game/core/src/main/java/net/minecraft/core/world/chunk/Chunk.java
+++ b/game/core/src/main/java/net/minecraft/core/world/chunk/Chunk.java
@@ -1,6 +1,9 @@
 package net.minecraft.core.world.chunk;
 
 import com.mojang.logging.LogUtils;
+import it.unimi.dsi.fastutil.ints.Int2ObjectArrayMap;
+import it.unimi.dsi.fastutil.ints.Int2ObjectMap;
+import net.minecraft.core.NextTickListEntry;
 import net.minecraft.core.block.Block;
 import net.minecraft.core.block.Blocks;
 import net.minecraft.core.block.entity.TileEntity;
@@ -23,17 +26,18 @@ public class Chunk
     public static final int CHUNK_SIZE_Z = 16;
     public static final int CHUNK_SECTIONS = 16;
     public static boolean isLit;
-
     public boolean isLoaded;
     public World world;
     public short[] heightMap;
     public int lowestY;
     public final int xPosition;
     public final int zPosition;
+    public long ticksOnUnload = -1;
     public Map<ChunkPosition, TileEntity> tileEntityMap;
     public double[] temperature;
     public double[] humidity;
     public double[] variety;
+    public @NotNull Int2ObjectMap<NextTickListEntry> tickList;
     public int averageBlockHeight;
     public boolean isTerrainPopulated;
     public boolean isModified;
@@ -56,6 +60,7 @@ public class Chunk
         temperature = new double[CHUNK_SIZE_X * CHUNK_SIZE_Z];
         humidity = new double[CHUNK_SIZE_X * CHUNK_SIZE_Z];
         variety = new double[CHUNK_SIZE_X * CHUNK_SIZE_Z];
+        tickList = new Int2ObjectArrayMap<>();
 
         for (int i = 0; i < sections.length; i++) {
             sections[i] = new ChunkSection(this, i);
@@ -92,6 +97,19 @@ public class Chunk
         heightMap[z * CHUNK_SIZE_X + x] = (short) y;
     }
 
+    public void addTick(final @NotNull NextTickListEntry entry) {
+        final @NotNull NextTickListEntry cloned = entry.clone();
+        cloned.x = cloned.x & (CHUNK_SIZE_X - 1);
+        cloned.z = cloned.z & (CHUNK_SIZE_Z - 1);
+        final int pos = NextTickListEntry.compressChunkCoord((short) entry.x, (short) entry.y, (short) entry.z);
+        this.tickList.put(pos, cloned);
+    }
+
+    public void dropTick(final @NotNull NextTickListEntry entry) {
+        final int pos = NextTickListEntry.compressChunkCoord((short) entry.x, (short) entry.y, (short) entry.z);
+        this.tickList.remove(pos);
+    }
+
     public void recalcHeightmapOnly()
     {
         int acc = 0;
@@ -522,7 +540,7 @@ public class Chunk
         setTileEntity(x, y, z, tileEntity);
         if(isLoaded)
         {
-            world.loadedTileEntityList.add(tileEntity);
+            world.tileEntityList.add(tileEntity);
         }
     }
 
@@ -582,6 +600,34 @@ public class Chunk
         for (ChunkSection section : sections) {
             section.onLoad(world);
         }
+
+        // Perform time correction on delayed ticks
+        if (this.ticksOnUnload >= 0) {
+            final long oldTime = this.ticksOnUnload;
+            final long newTime = this.world.getWorldTime();
+            for (final @NotNull NextTickListEntry entry : this.tickList.values()) {
+                final long ticksRemaining = entry.getEndTime() - oldTime;
+                entry.creationTime = newTime;
+                entry.delay = ticksRemaining;
+            }
+        }
+
+        if (this.xPosition == 0 && this.zPosition == 0) {
+            System.out.println("Loaded 0, 0");
+        }
+
+        this.scheduleLoadedUpdates();
+    }
+
+    private void scheduleLoadedUpdates() {
+        final @NotNull Int2ObjectMap<NextTickListEntry> oldTickList = this.tickList;
+        this.tickList = new Int2ObjectArrayMap<>();
+
+        final int worldX = this.xPosition * CHUNK_SIZE_X;
+        final int worldZ = this.zPosition * CHUNK_SIZE_Z;
+        for (final @NotNull NextTickListEntry entry : oldTickList.values()) {
+            this.world.scheduleBlockUpdate(worldX + entry.x, entry.y, worldZ + entry.z, entry.blockId, entry.delay, true);
+        }
     }
 
     public void onUnload()
@@ -596,6 +642,10 @@ public class Chunk
         for (ChunkSection section : sections) {
             section.onUnload(world);
         }
+
+        if (this.xPosition == 0 && this.zPosition == 0) {
+            System.out.println("Unloaded 0, 0");
+        }
     }
 
     public void setChunkModified()
diff --git a/game/core/src/main/java/net/minecraft/core/world/chunk/ChunkLoaderLegacy.java b/game/core/src/main/java/net/minecraft/core/world/chunk/ChunkLoaderLegacy.java
index 4b0154c8b..1914a817b 100644
--- a/game/core/src/main/java/net/minecraft/core/world/chunk/ChunkLoaderLegacy.java
+++ b/game/core/src/main/java/net/minecraft/core/world/chunk/ChunkLoaderLegacy.java
@@ -1,6 +1,7 @@
 package net.minecraft.core.world.chunk;
 
 import com.mojang.logging.LogUtils;
+import it.unimi.dsi.fastutil.ints.Int2ObjectArrayMap;
 import it.unimi.dsi.fastutil.ints.Int2ObjectMap;
 import net.minecraft.core.Global;
 import net.minecraft.core.block.entity.TileEntityDispatcher;
@@ -11,10 +12,7 @@ import com.mojang.nbt.tags.Tag;
 import com.mojang.nbt.tags.CompoundTag;
 import com.mojang.nbt.tags.ListTag;
 import com.mojang.nbt.NbtIo;
-import net.minecraft.core.world.chunk.reader.ChunkReader;
-import net.minecraft.core.world.chunk.reader.ChunkReaderLegacy;
-import net.minecraft.core.world.chunk.reader.ChunkReaderVersion1;
-import net.minecraft.core.world.chunk.reader.ChunkReaderVersion2;
+import net.minecraft.core.world.chunk.reader.*;
 import net.minecraft.core.world.chunk.writer.ChunkWriter;
 import net.minecraft.core.world.data.ChunkNibbleArray;
 import net.minecraft.core.world.data.ChunkUnsignedByteArray;
@@ -172,12 +170,13 @@ public class ChunkLoaderLegacy
         // Write tags
         writer.putXPos(chunk.xPosition);
         writer.putZPos(chunk.zPosition);
-        writer.putLastUpdate(world.getWorldTime());
+        writer.putTicksOnUnload(world.getWorldTime());
         writer.putHeightMap(chunk.heightMap);
         writer.putAverageBlockHeight(chunk.averageBlockHeight);
         writer.putTerrainPopulated(chunk.isTerrainPopulated);
         writer.putTemperatureMap(chunk.temperature);
         writer.putHumidityMap(chunk.humidity);
+        writer.putTickList(chunk.tickList);
 
         // Write sections
         for (int i = 0; i < Chunk.CHUNK_SECTIONS; i++) {
@@ -246,11 +245,13 @@ public class ChunkLoaderLegacy
         int x = reader.getX();
         int z = reader.getZ();
         Chunk chunk = new Chunk(world, x, z);
+        chunk.ticksOnUnload = reader.getTicksOnUnload();
         chunk.heightMap = reader.getHeightMap();
         chunk.averageBlockHeight = reader.getAverageBlockHeight();
         chunk.isTerrainPopulated = reader.getIsTerrainPopulated();
         chunk.temperature = reader.getTemperatureMap();
         chunk.humidity = reader.getHumidityMap();
+        chunk.tickList = reader.getTickList();
 
         // Read registries
         Int2ObjectMap<String> biomeRegistry = reader.getBiomeRegistry();
@@ -276,6 +277,9 @@ public class ChunkLoaderLegacy
             chunk.humidity = new double[256];
             Arrays.fill(chunk.humidity, Double.NEGATIVE_INFINITY);
         }
+        if (chunk.tickList == null) {
+            chunk.tickList = new Int2ObjectArrayMap<>();
+        }
 
         // Read entities
         ListTag entityListTag = tag.getList("Entities");
@@ -347,6 +351,8 @@ public class ChunkLoaderLegacy
                 return new ChunkReaderVersion1(world, tag);
             case 2:
                 return new ChunkReaderVersion2(world, tag);
+            case 3:
+                return new ChunkReaderVersion3(world, tag);
             default:
                 return new ChunkReaderLegacy(world, tag);
         }
diff --git a/game/core/src/main/java/net/minecraft/core/world/chunk/reader/ChunkReader.java b/game/core/src/main/java/net/minecraft/core/world/chunk/reader/ChunkReader.java
index 17fb38176..5c236d4a2 100644
--- a/game/core/src/main/java/net/minecraft/core/world/chunk/reader/ChunkReader.java
+++ b/game/core/src/main/java/net/minecraft/core/world/chunk/reader/ChunkReader.java
@@ -2,33 +2,49 @@ package net.minecraft.core.world.chunk.reader;
 
 import com.mojang.nbt.tags.CompoundTag;
 import it.unimi.dsi.fastutil.ints.Int2ObjectMap;
+import net.minecraft.core.NextTickListEntry;
 import net.minecraft.core.world.World;
 import net.minecraft.core.world.data.ChunkNibbleArray;
 import net.minecraft.core.world.data.ChunkUnsignedByteArray;
+import org.jetbrains.annotations.NotNull;
+import org.jetbrains.annotations.Nullable;
 
-import java.util.Map;
+public abstract class ChunkReader {
+    protected final @NotNull CompoundTag tag;
+    protected final @Nullable World world;
 
-public abstract class ChunkReader
-{
-    protected final CompoundTag tag;
-    protected final World world;
-
-    public ChunkReader(World world, CompoundTag chunkTag)
-    {
+    public ChunkReader(final @Nullable World world, final @NotNull CompoundTag chunkTag) {
         this.world = world;
         this.tag = chunkTag;
     }
+
     public abstract int getX();
+
     public abstract int getZ();
-    public abstract short[] getBlocks(int ySection);
-    public abstract ChunkUnsignedByteArray getData(int ySection);
-    public abstract ChunkNibbleArray getSkyLight(int ySection);
-    public abstract ChunkNibbleArray getBlockLight(int ySection);
-    public abstract short[] getHeightMap();
+
+    public abstract long getTicksOnUnload();
+
+    public abstract short @Nullable [] getBlocks(int ySection);
+
+    public abstract @Nullable ChunkUnsignedByteArray getData(int ySection);
+
+    public abstract @Nullable ChunkNibbleArray getSkyLight(int ySection);
+
+    public abstract @Nullable ChunkNibbleArray getBlockLight(int ySection);
+
+    public abstract short @Nullable [] getHeightMap();
+
     public abstract int getAverageBlockHeight();
+
     public abstract boolean getIsTerrainPopulated();
-    public abstract double[] getTemperatureMap();
-    public abstract double[] getHumidityMap();
-    public abstract byte[] getBiomeMap(int ySection, Int2ObjectMap<String> biomeRegistry);
-    public abstract Int2ObjectMap<String> getBiomeRegistry();
+
+    public abstract double @Nullable [] getTemperatureMap();
+
+    public abstract double @Nullable [] getHumidityMap();
+
+    public abstract byte @Nullable [] getBiomeMap(int ySection, @NotNull Int2ObjectMap<String> biomeRegistry);
+
+    public abstract @Nullable Int2ObjectMap<String> getBiomeRegistry();
+
+    public abstract @Nullable Int2ObjectMap<NextTickListEntry> getTickList();
 }
